from pyspark.context import SparkContext
from pyspark.sql.session import SparkSession

import operator
from copy import copy

def apply_discount(tran):
    if int(tran[3]) == 25 and int(tran[4]) > 1:
        print(tran)
        tran[5] = str(float(tran[5]) * 0.95)
    return tran

def add_prod_70(tran):
    if int(tran[3]) == 81 and int(tran[4]) > 4:
        gift = copy(tran)
        gift[3] = '70'
        gift[4] = '1'
        gift[5] = '0.0'
        return [tran, gift]
    else:
        return [tran]

if __name__ == '__main__':
    sc = SparkContext('local')
    spark = SparkSession(sc)

    tran_file = sc.textFile('data/ch04_data_transactions.txt')
    tran_data = tran_file.map(lambda t: t.split('#'))
    tran_by_cust = tran_data.map(lambda t: (int(t[2]), t))
    print(tran_by_cust.keys().distinct().count())
    # print(tran_by_cust.collect())

    cust_counts = tran_by_cust.countByKey()
    print(type(cust_counts))
    print(cust_counts)

    cust_id, cnt = sorted(cust_counts.items(), key=operator.itemgetter(1))[-1]
    print(cust_id, cnt)

    print(tran_by_cust.lookup(53))
    gift1 = [['2022.10.28', '17:33', 53, 4, 1, 0.0]]

    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 25).collect())
    tran_by_cust = tran_by_cust.mapValues(lambda t: apply_discount(t))
    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 25).collect())

    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 70).collect())
    tran_by_cust = tran_by_cust.flatMapValues(lambda t: add_prod_70(t))
    print(tran_by_cust.filter(lambda t: int(t[1][3]) == 70).collect())