from pyspark.context import SparkContext
from pyspark.sql.session import SparkSession
from pyspark.sql.types import BooleanType
from pyspark.sql import functions as F

@F.udf(returnType=BooleanType())
def isemp(user):
    return user in bc_employees.value

if __name__ == '__main__':
    sc = SparkContext('local')
    spark = SparkSession(sc)

    log = spark.read.json('data/2015-01-01-0.json')
    print(type(log))

    log.printSchema()
    print(log.count())

    pushes = log.filter(log.type == 'PushEvent')
    print(pushes.count())

    grouped = log.groupBy(log.actor.login).count()
    grouped.show(5)

    ordered = grouped.orderBy(grouped["count"].desc())
    ordered.show(5)

    employees = set(line.strip() for line in open('data/employees.txt'))
    bc_employees = sc.broadcast(employees)
    filtered = ordered.filter(isemp("actor[login]"))
    print(filtered.count())
    filtered.show()